function Component()
{
	installer.finishButtonClicked.connect(this, Component.prototype.installationFinished);
	component.enabled = this.isDefault();	
}

Component.prototype.isDefault = function()
{
	var retVal = true;
	
	if ( systemInfo.currentCpuArchitecture == "i386" && component.name == "com.phonalisa.tapidriver.x64" ){
		retVal = false
	}
	else if (  systemInfo.currentCpuArchitecture == "x86_64" && component.name == "com.phonalisa.tapidriver.x86" ){
		retVal = false
	}
	
	return retVal;
}


Component.prototype.createOperations = function()
{
    component.createOperations();
	
	var path 	 = installer.value("HKEY_LOCAL_MACHINE\\SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment\\Path");
        var binDir 	 = installer.value("TargetDir") + "\\TAPIDriver\\bin";
	var winDir   = installer.environmentVariable("windir");
	var appData  = installer.environmentVariable("APPDATA");
	
	var startupPath = appData +"\\Microsoft\\Windows\\Start Menu\\Programs\\Startup";
	
	if ( path.indexOf(binDir) === -1 ){
		
		path += ";" + binDir;
		component.addOperation(	"Execute", 
								"REG", 
								"ADD", 
								"HKEY_LOCAL_MACHINE\\SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment",
								"/v",
								"Path",
								"/t",
								"REG_EXPAND_SZ",
								"/d",
								path,
								"/f"
								);		
	}

	component.addOperation("Copy", installer.value("TargetDir") + "/TAPIDriver/bin/PhonalisaTAPIDriver.tsp", winDir + "\\PhonalisaTAPIDriver.tsp" );
	component.addOperation("Copy", installer.value("TargetDir") + "/TAPIDriver/bin/PhonalisaTAPIInstaller.exe", winDir + "\\PhonalisaTAPIInstaller.exe" );
	
	component.addOperation("Copy", installer.value("TargetDir") + "/TAPIDriver/bin/msvcp120.dll", winDir + "\\msvcp120.dll" );
	component.addOperation("Copy", installer.value("TargetDir") + "/TAPIDriver/bin/msvcr120.dll", winDir + "\\msvcr120.dll" );
	

	
	component.addOperation(	"CreateShortcut", 
							installer.value("TargetDir") + "\\TAPIDriver\\bin\\PhonalisaTAPIInstaller.exe", 
							installer.value("StartMenuDir")+"/TAPI Treiber Konfigurieren.lnk", 
							"--showConfig",
							"workingDirectory=" + winDir,
							"iconPath=%SystemRoot%/system32/SHELL32.dll",
							"iconId=2");
							
	component.addOperation(	"CreateShortcut", 
							 installer.value("TargetDir") + "\\Paketverwaltung.exe", 
							 installer.value("StartMenuDir") + "\\Paketverwaltung.lnk", 
							 "workingDirectory=" + installer.value("TargetDir") );
	
	component.addOperation(	"Execute", 
								"REG", 
								"ADD", 
								"HKEY_LOCAL_MACHINE\\SOFTWARE\\Phonalisa Europe GmbH\\PhonalisaTAPIDriver\\UserData",
								"/v",
								"installationDir",
								"/t",
								"REG_SZ",
								"/d",
								installer.value("TargetDir"),
								"/f");
								
	component.addOperation(	"Execute", 
								"REG", 
								"ADD", 
								"HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\RunOnce",
								"/v",
								"start",
								"/t",
								"REG_SZ",
								"/d",
								installer.value("TargetDir") + "\\TAPIDriver\\bin\\PhonalisaTAPIInstaller.exe",
								"/f");
								

}

Component.prototype.installationFinished = function()
{	
	if ( installer.status == QInstaller.Success && installer.isInstaller() ){
	var result = QMessageBox["question"]("restart", "Phonalisa TAPI Client Installer", "Um die Installation korrekt fortzusetzen, muss ihr System jetzt neu gestartet werden.<br>", QMessageBox.Ok|QMessageBox.Cancel);
		
		if (result == QMessageBox.Ok) {
		installer.execute( "shutdown.exe", ["/r", "/t", "3"] )
		}
	}
}

